<?php

/**
 * v2 地图模块
 */
namespace app\em\controller;

use app\admin\controller\Base;
use app\admin\model\ElectricMeter;
use app\admin\model\OperatorModel;
use think\db;
use think\Exception;
use think\facade\Request;
use think\facade\Session;

class Region extends Base
{


    public function region_list(){
           $db = Db::connect([
                    'type'            => config('jz.jztype'),
                    'hostname'        => config('jz.jzhostname'),
                    'database'        => config('jz.jzdatabase'),
                    'username'        => config('jz.jzusername'),
                    'password'        => config('jz.jzpassword'),
                    'hostport'        =>config('jz.jzhostport'),
                    'charset'         => config('jz.jzcharset'),
                ]);

        if (!Request::instance()->isAjax()){
            $this->assign('search_type','');
            $this->assign('search_text','');
            $this->assign('operator','');
            $this->assign('area_id','');
            $region=new ElectricMeter();
            $operator=new OperatorModel();
            $operators = OperatorModel::field('operator_id,operator_name')->where('operator_state','=',1)->select()->toArray();
            $this->assign('regions',getTree($region->regions()));
            $this->assign('operators',$operators);
            return $this->fetch();
        }else{
            $map=[];
            $aa= Request::param('type');
             if($aa==1){
                $data= Request::param('data');
                $search_text=$data['search_text'];
                $search_type=$data['search_type'];
        if($search_text){
            switch ($search_type) {
                case '1':
                    $this->assign('search_text',$search_text);
                    $map[]=['jz_name','like',"%$search_text%"];
                    $this->assign('search_type',$search_type);
                    break;
                case '2':
                    $this->assign('search_text',$search_text);
                    $map[]=['jz_code','like',"%$search_text%"];
                    $this->assign('search_type',$search_type);
                    break;
                case '3':
                    $this->assign('search_text',$search_text);
                    $map[]=['project_code','like',"%$search_text%"];
                    $this->assign('search_type',$search_type);
                    break;
              
            }
        }else{
            $this->assign('search_type','');
            $this->assign('search_text','');
        }
               
          
            // $operator = $data['operator'];
            // if($operator){
            // $map[] = ['jz_yys','=',$operator];
            // $this->assign('operator',$operator);
            // }else{
            // $this->assign('operator','');
            // }
            // $area_id =$data['area_id'];
            // if($area_id){
            // $map[] = ['jz_qy','=',$area_id];
            // $this->assign('area_id',$area_id);
            // }else{
            // $this->assign('area_id','');
            // }
            if(!$map){
                 echo 0;die;
            }
            
                //权限检测
                $user = Session::get('user');
                if(!$user['is_admin']){
                $permissionData=check_data();
                if($permissionData){
                $map[]=$permissionData;
                }
                }
                 $map[] = ['jz_latitude','neq',""];
                 $map[] = ['jz_latitude','neq',""];
               
               
                $datalist=  $db->table('jz_message')->field('business_id,jz_name,project_code,jz_longitude,jz_latitude')->where($map)->select();
               
                 
                 if(!$datalist){
                        echo 0;die;
                    }
                 $lats = $lons = array();
                            foreach ($datalist as $key => $value) {
                                array_push($lats, $value['jz_latitude']);
                                array_push($lons, $value['jz_longitude']);
                            }
                        $minlat = min($lats);
                        $maxlat = max($lats);
                        $minlon = min($lons);
                        $maxlon = max($lons);

                        $zpoint = [
                            'minLat'=>$minlat,
                            'maxLat'=>$maxlat,
                            'minLng'=>$minlon,
                            'maxLng'=>$maxlon
                        ];
                        $lat = $maxlat - (($maxlat - $minlat) / 2);
                        $lng = $maxlon - (($maxlon - $minlon) / 2);
                        $oPoint=array("latitude" => $lat, "longitude" => $lng);
                        $datalist['oPoint'] = $oPoint;
                        $datalist['zPoint'] = $zpoint;



             }else{
                $map1=[];
                // //权限检测
                $user = Session::get('user');
                if(!$user['is_admin']){
                $permissionData=check_data();
                if($permissionData){
                $map1[]=$permissionData;
                 }
                }
                $position= Request::param('point');
                $arr=json_decode($position,true);
                $zd=$arr['Zd'];
                $xd=$arr['Xd'];
                $ne=$arr['Ne'];
                $je=$arr['Je'];
                $map1[] = ['jz_longitude','between',"$ne,$je"];
                $map1[] = ['jz_latitude','between',"$zd,$xd"];


               $datalist=  $db->table('jz_message')->field('business_id,jz_name,project_code,jz_longitude,jz_latitude')->where($map1)->select();


            

             }
              if(!$datalist){
                        echo 0;die;
                    }
              
                if($datalist){
                    echo json_encode($datalist);
                }
                
       }
    }


   
}