<?php


namespace app\admin\validate;


use think\Validate;

class FkAddValidate extends Validate
{
    protected $rule = [
        'title' => 'require',
        'payee' => 'require',
        'payOrg' => 'require',
        'date' => 'require|date',
        'fkinfo' => 'require'
    ];

    protected $message = [
        'title.require' => '标题必填',
        'payee.require' => '收款方必填',
        'payOrg.require' => '付款组织必填',
        'date.require' => '日期必填',
        'date.date' => '日期格式错误'
    ];
}