<?php
namespace app\em\validate;
use think\Validate;

class AddFkInfoValidate extends Validate
{
    protected $rule = [
        'title' => 'require',
        'info' => 'require',
        'date' => 'require|date'
    ];

    protected  $message = [
        'title.require' => '标题不能为空',
        'info.require' => '付款信息不能为空,请选择收款方之后自动补充付款信息,如果选择收款方之后付款信息依然为空,则需要通过OA补充收款方的付款信息',
        'date.require' => '日期不能为空',
        'date.date' => '日期格式不正确'
    ];
}